require 'sdl'

keybind = []
for i in SDL::Key::FIRST..SDL::Key::LAST
  keybind[i] = Array.new( 8, "NULL" )
end

keybind[ SDL::Key::SPACE ] = [
  "space_on_j_kakutei_mode",
  "space_on_j_henkan_on_mode",
  "NULL",
  "space_on_j_henkan_active_mode",
  "space_on_latin_mode",
  "graph_on_jisx0208_latin_mode",
  "space_on_abbrev_mode",
]

for i in SDL::Key::EXCLAIM..SDL::Key::BACKQUOTE
  keybind[i] = [
    "SDLSKK_Context_input_key",
    "SDLSKK_Context_input_key",
    "SDLSKK_Context_input_key",
    "SDLSKK_Context_input_key",
    "SDLSKK_Context_input_key",
    "SDLSKK_Context_input_key",
    "SDLSKK_Context_input_key",
  ]
end

for i in SDL::Key::A..SDL::Key::Z
  keybind[i] = [
    "SDLSKK_Context_input_key",
    "SDLSKK_Context_input_key",
    "SDLSKK_Context_input_key",
    "SDLSKK_Context_input_key",
    "SDLSKK_Context_input_key",
    "SDLSKK_Context_input_key",
    "SDLSKK_Context_input_key",
  ]
end

keybind[SDL::Key::RIGHT] = [
  "forward_on_j_kakutei_mode",
  "NULL",
  "NULL",
  "NULL",
  "forward_on_latin_mode",
  "forward_on_latin_mode",
  "NULL",
]

keybind[SDL::Key::LEFT] = [
  "backward_on_j_kakutei_mode",
  "NULL",
  "NULL",
  "NULL",
  "backward_on_latin_mode",
  "backward_on_latin_mode",
  "NULL",
]

keybind[SDL::Key::BACKSPACE] = [
  "backspace_on_j_kakutei_mode",
  "backspace_on_j_henkan_on_mode",
  "backspace_on_j_henkan_okuri_mode",
  "NULL",
  "backspace_on_latin_mode",
  "backspace_on_latin_mode",
  "backspace_on_abbrev_mode",
]

keybind[SDL::Key::DELETE] = [
  "delete_on_j_kakutei_mode",
  "NULL",
  "NULL",
  "NULL",
  "delete_on_latin_mode",
  "delete_on_latin_mode",
  "NULL",
]

print 'static SDLSKK_Keybind default_sdl_keybind[][7] = {', "\n"
keybind.each do |a|
  print '  { '
  for i in 0..6 do
    print a[i], ", "
  end
  print "},\n"
end
print "};\n"
